<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEcoAssistantDayItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfEcoAssistantDayItem extends AbstractStructArrayBase
{
    /**
     * The EcoAssistantDayItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EcoAssistantDayItem[]
     */
    public $EcoAssistantDayItem;
    /**
     * Constructor method for ArrayOfEcoAssistantDayItem
     * @uses ArrayOfEcoAssistantDayItem::setEcoAssistantDayItem()
     * @param \StructType\EcoAssistantDayItem[] $ecoAssistantDayItem
     */
    public function __construct(array $ecoAssistantDayItem = array())
    {
        $this
            ->setEcoAssistantDayItem($ecoAssistantDayItem);
    }
    /**
     * Get EcoAssistantDayItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EcoAssistantDayItem[]|null
     */
    public function getEcoAssistantDayItem()
    {
        return isset($this->EcoAssistantDayItem) ? $this->EcoAssistantDayItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEcoAssistantDayItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEcoAssistantDayItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEcoAssistantDayItemForArrayConstraintsFromSetEcoAssistantDayItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEcoAssistantDayItemEcoAssistantDayItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfEcoAssistantDayItemEcoAssistantDayItemItem instanceof \StructType\EcoAssistantDayItem) {
                $invalidValues[] = is_object($arrayOfEcoAssistantDayItemEcoAssistantDayItemItem) ? get_class($arrayOfEcoAssistantDayItemEcoAssistantDayItemItem) : sprintf('%s(%s)', gettype($arrayOfEcoAssistantDayItemEcoAssistantDayItemItem), var_export($arrayOfEcoAssistantDayItemEcoAssistantDayItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EcoAssistantDayItem property can only contain items of type \StructType\EcoAssistantDayItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EcoAssistantDayItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EcoAssistantDayItem[] $ecoAssistantDayItem
     * @return \ArrayType\ArrayOfEcoAssistantDayItem
     */
    public function setEcoAssistantDayItem(array $ecoAssistantDayItem = array())
    {
        // validation for constraint: array
        if ('' !== ($ecoAssistantDayItemArrayErrorMessage = self::validateEcoAssistantDayItemForArrayConstraintsFromSetEcoAssistantDayItem($ecoAssistantDayItem))) {
            throw new \InvalidArgumentException($ecoAssistantDayItemArrayErrorMessage, __LINE__);
        }
        if (is_null($ecoAssistantDayItem) || (is_array($ecoAssistantDayItem) && empty($ecoAssistantDayItem))) {
            unset($this->EcoAssistantDayItem);
        } else {
            $this->EcoAssistantDayItem = $ecoAssistantDayItem;
        }
        return $this;
    }
    /**
     * Add item to EcoAssistantDayItem value
     * @throws \InvalidArgumentException
     * @param \StructType\EcoAssistantDayItem $item
     * @return \ArrayType\ArrayOfEcoAssistantDayItem
     */
    public function addToEcoAssistantDayItem(\StructType\EcoAssistantDayItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EcoAssistantDayItem) {
            throw new \InvalidArgumentException(sprintf('The EcoAssistantDayItem property can only contain items of type \StructType\EcoAssistantDayItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EcoAssistantDayItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EcoAssistantDayItem
     */
    public function getAttributeName()
    {
        return 'EcoAssistantDayItem';
    }
}
